from reportlab.pdfgen import canvas
from reportlab.lib.pagesizes import A4
from reportlab.lib.units import cm
import string, cStringIO

# Import a standard function, and get the HTML request and response objects.
from Products.PythonScripts.standard import html_quote

filename = 'titelseite.pdf'

def remotetitle(self):

 #einstellungen = getattr(self,'getSettings')()
 einstellungen = ({'show_vorname': self.REQUEST.form['show_vorname'], 'show_nachname': self.REQUEST.form['show_nachname'], 'show_schule': self.REQUEST.form['show_schule'], 'show_klasse': self.REQUEST.form['show_klasse'], 'vorname': self.REQUEST.form['vorname'], 'nachname': self.REQUEST.form['nachname'], 'schule': self.REQUEST.form['schule'], 'klasse': self.REQUEST.form['klasse']})

 titel = self.REQUEST.form['titel'].split(' ')
 name = ''
 if (einstellungen['show_vorname'] == "1"): name += einstellungen['vorname']
 if (einstellungen['show_vorname'] == "1" and einstellungen['show_nachname'] == "1"): name += ' ' 
 if (einstellungen['show_nachname'] == "1"): name += einstellungen['nachname']
 schule = ''
 if (einstellungen['show_schule'] == "1"): schule += einstellungen['schule']
 if (einstellungen['show_schule'] == "1" and einstellungen['show_klasse'] == "1"): schule += ', '
 if (einstellungen['show_klasse'] == "1"): schule += einstellungen['klasse']

 report = cStringIO.StringIO()
 c = canvas.Canvas(report,pagesize=A4)

 c.setFont("Helvetica",36)
 y = 22.0

 titellines = []
 line = ''
 for word in titel:
  if c.stringWidth(line+' '+word,'Helvetica',36) < 16*cm: line += ' '+word
  else:
   titellines.append(line)
   line = word
 titellines.append(line)

 for line in titellines:
  c.drawCentredString(10.45*cm,y*cm,str(line)) #.decode('utf-8').encode('iso-8859-15'))
  y -= 1.5
 c.setFont("Helvetica",18)
 y -= 1
 c.drawCentredString(10.45*cm,y*cm,str(name)) #.decode('utf-8').encode('iso-8859-15'))
 y -= 1.5
 c.setFont("Helvetica",14)
 c.drawCentredString(10.45*cm,y*cm,str(schule)) #.decode('utf-8').encode('iso-8859-15'))

 # show teh zeug
 c.showPage()
 c.save()
 content = report.getvalue()
 self.REQUEST.RESPONSE.setHeader('Content-Type', 'application/pdf')
 self.REQUEST.RESPONSE.setHeader('Content-Disposition', 'attachment; filename=%s' % filename)

 return content

