#!/usr/bin/env python
import sys
import string, cStringIO

sys.path.append( '../' )

from PyRTF import *

report = cStringIO.StringIO()

def pyrtf(self):
	zusammenfassung = getattr(self,'getZusammenfassung')(self.REQUEST.referat)
	filename = self.REQUEST.referat+'.rtf'
	if zusammenfassung == []: 
		self.REQUEST.RESPONSE.redirect('leere_praesentation',lock=0)
		return False
		
	report = cStringIO.StringIO()

        doc     = Document()
        ss      = doc.StyleSheet
        section = Section()
        doc.Sections.append( section )
	
	for abschnitt in zusammenfassung:
		titel = abschnitt[0]
		text = abschnitt[1]+"\n\n"
	        p = Paragraph( ss.ParagraphStyles.Heading1 )
		p.append( str(titel) )
		section.append( p )
		lines = text.splitlines()
		tmp = ''

	        for line in lines:
	                if (line != ''):
	                        if (tmp != ''): tmp += '\line ' +line
	                        else: tmp = line
	                else:
	                        p = Paragraph( ss.ParagraphStyles.Heading2 )
	                        p.append( str(tmp) )
	                        section.append( p )
	                        tmp = ''
	DR = Renderer()
	DR.Write(doc,report)

	content = report.getvalue()
	self.REQUEST.RESPONSE.setHeader('Content-Type', 'application/rtf')
	self.REQUEST.RESPONSE.setHeader('Content-Disposition', 'attachment; filename=%s' % filename)

	return content
