#!/usr/bin/env python
import sys, os
import string, cStringIO

sys.path.append( '../' )

from PyRTF import *

try:
	tmppath = os.environ['TEMP']
except:
	tmppath = '/tmp/'
report = cStringIO.StringIO()

def pyrtf(self):
	try:
		import win32com.client
		import pythoncom
		zusammenfassung = getattr(self,'getZusammenfassung')(self.REQUEST.referat)
		filename = self.REQUEST.referat+'.rtf'
		if zusammenfassung == []: 
			self.REQUEST.RESPONSE.redirect('leere_praesentation',lock=0)
			return False

		report = cStringIO.StringIO()

	        doc     = Document()
	        ss       = doc.StyleSheet
	        section = Section()
	        doc.Sections.append( section )
	
		for abschnitt in zusammenfassung:
			titel = str(abschnitt[0]) 
			text = str(abschnitt[1])+"\n\n"
		        p = Paragraph( ss.ParagraphStyles.Heading1 )
			p.append( str(titel) )
			section.append( p )
			lines = text.splitlines()
			tmp = ''

		        for line in lines:
		                if (line != ''):
		                        if (tmp != ''): tmp += '\line ' +line
		                        else: tmp = line
		                else:
		                        p = Paragraph( ss.ParagraphStyles.Heading2 )
		                        p.append( str(tmp) )
		                        section.append( p )
		                        tmp = ''

		DR = Renderer()
		DR.Write(doc,report)

		content = report.getvalue()
		rtfpath = tmppath + os.tmpnam() + '.rtf'
		open(rtfpath, 'wb').write(content)

		pythoncom.CoInitialize()
		ppt = win32com.client.Dispatch('PowerPoint.Application')
		ppt.Visible = 1
		ppt.Presentations.Open(rtfpath,False,True,True)
	except:
		self.REQUEST.RESPONSE.redirect('kein_office',lock=0)
